models/Numeros.php
<?php
namespace app\models;
use yii\base\Model;

class Numeros extends Model{ 
    public $numero1;
    public $numero2;
    public $tipo;
    public $sumar;
    public $restar;
    public $dividir;
    public $multiplicar;
    
    
    
    public function attributeLabels(){
        return[
            "numero1"=>"Numero 1",
            "numero2"=>"Numero 2",
            "sumar" =>"La suma es",
            "restar" =>"La resta es",
            "multiplicar" => "El producto es",
            "dividir" => "El cociente es"
        ];
    }
    
    public function rules(){
        return [
          [['numero1','numero2'],'integer'],
          [['numero1','numero2'],'required'],
          /*['numero2', 'compare', 'compareValue' => 0, 'operator' => '!=', 'type' => 'number','when'=>function($model){
                return $model->tipo=="dividir"; // solo realiza la validacion si la operacion es dividir
          }]*/
          ['numero2','dividirPorCero'],
        ];
    }
    
    /**
     *  Esta regla me comprueba cuando estoy diviendo que el numero 2 (denominador) no sea cero
     * @param type $atributo
     * @param type $parametros
     */
    public function dividirPorCero($atributo,$parametros){
        if($this->tipo=="dividir" || $this->tipo=="todo"){
            if($this->numero2==0){
                $this->addError("numero2","No puede ser un cero si estas dividiendo");
            }
        }
        
    }
    
    public function operacion(){
        switch ($this->tipo){
            case 'sumar':
                return $this->numero1+$this->numero2;
                break;
            case 'restar':
                return $this->numero1-$this->numero2;
                break;
            case 'multiplicar':
                return $this->numero1*$this->numero2;
                break;
            case 'dividir':
                return $this->numero1/$this->numero2;
                break;
            default:
                return 0;
            
        }

    }
    
    public function operarTodo(){
        $this->sumar=$this->numero1+$this->numero2;
        $this->restar=$this->numero1-$this->numero2;
        $this->multiplicar=$this->numero1*$this->numero2;
        $this->dividir=$this->numero1/$this->numero2;
    }
    
    
    

}

controllers/SiteController.php
<?php

namespace app\controllers;

use Yii;
use yii\filters\AccessControl;
use yii\web\Controller;
use yii\web\Response;
use yii\filters\VerbFilter;
use app\models\LoginForm;
use app\models\ContactForm;
use app\models\Numeros;

class SiteController extends Controller
{
    /**
     * {@inheritdoc}
     */
    public function behaviors()
    {
        return [
            'access' => [
                'class' => AccessControl::className(),
                'only' => ['logout'],
                'rules' => [
                    [
                        'actions' => ['logout'],
                        'allow' => true,
                        'roles' => ['@'],
                    ],
                ],
            ],
            'verbs' => [
                'class' => VerbFilter::className(),
                'actions' => [
                    'logout' => ['post'],
                ],
            ],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function actions()
    {
        return [
            'error' => [
                'class' => 'yii\web\ErrorAction',
            ],
            'captcha' => [
                'class' => 'yii\captcha\CaptchaAction',
                'fixedVerifyCode' => YII_ENV_TEST ? 'testme' : null,
            ],
        ];
    }

    /**
     * Displays homepage.
     *
     * @return string
     */
    public function actionIndex()
    {
        return $this->render('index');
    }
    
    public function actionSumar()
    {
        $model=new Numeros();
        $model->tipo="sumar";        
        
        $datos=Yii::$app->request->post(); // recoger lo que me manda el formulario
        
        // compruebo si me llega algo del formulario y cumple las rules
        if($model->load($datos) && $model->validate()){ 
            // realizo la suma
            $resultado=$model->operacion();
            //mando la suma a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                 "operacion" => "suma"
            ]);
        }
        
        // si no ha entrado en el if anterior cargo el formulario vacio o con errores
        return $this->render('numeros',[
            "model" => $model,
            "operacion" => "Sumar"
        ]);
        
        
    }
    
    public function actionRestar()
    {
         $model=new Numeros();
         $model->tipo="restar";        
        
        $datos=Yii::$app->request->post(); // recoger lo que me manda el formulario
        
        // compruebo si me llega algo del formulario y cumple las rules
        if($model->load($datos) && $model->validate()){ 
            // realizo la suma
            $resultado=$model->operacion();
            //mando la suma a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                 "operacion" => "resta"
            ]);
        }
        
        // si no ha entrado en el if anterior cargo el formulario vacio o con errores
        return $this->render('numeros',[
            "model" => $model,
            "operacion" => "Restar"
        ]);
    }
    
    public function actionMultiplicar()
    {
          $model=new Numeros();
          $model->tipo="multiplicar";        
        
        $datos=Yii::$app->request->post(); // recoger lo que me manda el formulario
        
        // compruebo si me llega algo del formulario y cumple las rules
        if($model->load($datos) && $model->validate()){ 
            // realizo la suma
            $resultado=$model->operacion();
            //mando la suma a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                "operacion" => "multiplicacion"
            ]);
        }
        
        // si no ha entrado en el if anterior cargo el formulario vacio o con errores
        return $this->render('numeros',[
            "model" => $model,
            "operacion" => "Multiplicar"
        ]);
    }
    
    public function actionDividir()
    {
        $model=new Numeros();
        $model->tipo="dividir";        
        
        $datos=Yii::$app->request->post(); // recoger lo que me manda el formulario
        
        // compruebo si me llega algo del formulario y cumple las rules
        if($model->load($datos) && $model->validate()){ 
            // realizo la suma
            $resultado=$model->operacion();
            //mando la suma a la vista
            return $this->render("resultado",[
                "resultado" => $resultado,
                "operacion" => "division"
            ]);
        }
        
        // si no ha entrado en el if anterior cargo el formulario vacio o con errores
        return $this->render('numeros',[
            "model" => $model,
            "operacion" => "Dividir"
        ]);
    }
    
    
    public function actionOperar(){
        $model=new Numeros();
        $model->tipo="todo";        
        
        $datos=Yii::$app->request->post(); // recoger lo que me manda el formulario
        
        // compruebo si me llega algo del formulario y cumple las rules
        if($model->load($datos) && $model->validate()){ 
            // realizo todas las operaciones
            $model->operarTodo();
            //mando la suma a la vista
            return $this->render("mostrarTodo",[
                "model" => $model
            ]);
        }
        
        // si no ha entrado en el if anterior cargo el formulario vacio o con errores
        return $this->render('numeros',[
            "model" => $model,
            "operacion" => "Calcular"
        ]);
    }
   
}

views/layouts/main.php
<?php

/* @var $this \yii\web\View */
/* @var $content string */

use app\assets\AppAsset;
use app\widgets\Alert;
use yii\bootstrap4\Breadcrumbs;
use yii\bootstrap4\Html;
use yii\bootstrap4\Nav;
use yii\bootstrap4\NavBar;

AppAsset::register($this);
?>
<?php $this->beginPage() ?>
<!DOCTYPE html>
<html lang="<?= Yii::$app->language ?>" class="h-100">
<head>
    <meta charset="<?= Yii::$app->charset ?>">
    <meta name="viewport" content="width=device-width, initial-scale=1, shrink-to-fit=no">
    <?php $this->registerCsrfMetaTags() ?>
    <title><?= Html::encode($this->title) ?></title>
    <?php $this->head() ?>
</head>
<body class="d-flex flex-column h-100">
<?php $this->beginBody() ?>

<header>
    <?php
    NavBar::begin([
        'brandLabel' => Yii::$app->name,
        'brandUrl' => Yii::$app->homeUrl,
        'options' => [
            'class' => 'navbar navbar-expand-md navbar-dark bg-dark fixed-top',
        ],
    ]);
    echo Nav::widget([
        'options' => ['class' => 'navbar-nav'],
        'items' => [
            ['label' => 'Home', 'url' => ['/site/index']],
            ['label' => 'Sumar', 'url' => ['/site/sumar']],
            ['label' => 'Restar', 'url' => ['/site/restar']],
            ['label' => 'Multiplicar', 'url' => ['/site/multiplicar']],
            ['label' => 'Dividir', 'url' => ['/site/dividir']],
            ['label' => 'Operar Todo', 'url' => ['/site/operar']],
            
        ],
    ]);
    NavBar::end();
    ?>
</header>

<main role="main" class="flex-shrink-0">
    <div class="container">
        <?= Breadcrumbs::widget([
            'links' => isset($this->params['breadcrumbs']) ? $this->params['breadcrumbs'] : [],
        ]) ?>
        <?= Alert::widget() ?>
        <?= $content ?>
    </div>
</main>

<footer class="footer mt-auto py-3 text-muted">
    <div class="container">
        <p class="float-left">Desarrollado curso Programacion Orientada a Objetos 2021</p>
        <p class="float-right">Ramon Abramo</p>
    </div>
</footer>

<?php $this->endBody() ?>
</body>
</html>
<?php $this->endPage() ?>

views/site/error.php
<?php

/* @var $this yii\web\View */
/* @var $name string */
/* @var $message string */
/* @var $exception Exception */

use yii\helpers\Html;

$this->title = $name;
?>
<div class="site-error">

    <h1><?= Html::encode($this->title) ?></h1>

    <div class="alert alert-danger">
        <?= nl2br(Html::encode($message)) ?>
    </div>

    <p>
        The above error occurred while the Web server was processing your request.
    </p>
    <p>
        Please contact us if you think this is a server error. Thank you.
    </p>

</div>

views/site/index.php
<?php

/* @var $this yii\web\View */

$this->title = 'Practica 5';
?>
<div class="site-index">
   
    <div class="body-content">

        <div class="row">
            <div class="mx-auto col-lg-8 text-justify">
                <h2 class="mb-3">Pagina de Inicio</h2>

                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>
                <p>Lorem ipsum dolor sit amet, consectetur adipisicing elit, sed do eiusmod tempor incididunt ut labore et
                    dolore magna aliqua. Ut enim ad minim veniam, quis nostrud exercitation ullamco laboris nisi ut aliquip
                    ex ea commodo consequat. Duis aute irure dolor in reprehenderit in voluptate velit esse cillum dolore eu
                    fugiat nulla pariatur.</p>

                
            </div>
        </div>
   </div>
</div>

views/site/mostrarTodo.php
<?php

use yii\widgets\DetailView;

echo DetailView::widget([
    "model" => $model,
    "attributes"=>[
        'numero1',
        'numero2',
        'sumar',
        'restar',
        'multiplicar',
        'dividir'
    ]
]);

views/site/numeros.php
<?php

use yii\helpers\Html;
use yii\widgets\ActiveForm;

/* @var $this yii\web\View */
/* @var $model app\models\Sumar */
/* @var $form ActiveForm */
?>
<div class="sumar">

    <?php $form = ActiveForm::begin(); ?>

        <?= $form->field($model, 'numero1') ?>
        <?= $form->field($model, 'numero2') ?>
    
        <div class="form-group">
            <?= Html::submitButton($operacion, ['class' => 'btn btn-primary']) ?>
        </div>
    <?php ActiveForm::end(); ?>

</div><!-- sumar -->

views/site/resultado.php
<div class="col-lg-8 mx-auto bg-primary p-3 rounded text-white mt-4">
    El resultado de la <?= $operacion ?> es <?= $resultado ?>
</div>